# -*- coding: utf-8 -*-
"""
Created on Tue Feb  1 12:12:32 2022

@author: frede

"""
"Calcul de la période en utilisant la méthode d'Euler"

import matplotlib.pyplot as plt
import numpy as np



def Demiperiode(theta0):
    m = 0.2
    a = 0.5
    g=9.8

    deltat=0.0001
    theta0=theta0*np.pi/180
    omega0=0
    t=0
    theta = theta0
    omega = omega0

    while theta > -theta0 :
        t = t + deltat
        
        theta=theta+omega*deltat
        
        omega=omega-3*g/2/a*np.sin(theta)*deltat
        
    return t
    
Tcalc = 2* Demiperiode(60)
print('Période : ', Tcalc)

listampl=[]
theta0min = 5 #angle d'amplitude minimal en degrés
theta0max = 175 #angle d'amplitude maximal en degrés
delta = 5 #pas d'inventaire des valeurs de theta0
theta0 = theta0min
Période = []
Amplitude = []
while theta0 < theta0max : 
    T = 2*Demiperiode(theta0)
    Amplitude .append(theta0)
    theta0 = theta0 + delta
    Période.append(T)
    
plt.clf()
plt.plot(Amplitude,Période)
plt.show()


#Pour confronter à l'observation du mouvement#
"Etude du mouvement par la méthode d'Euler"
from scipy import *
from pylab import *

m = 0.2
a = 0.50
g = 9.8

deltat=0.001
theta0=0
omega0=3
t=0
theta = theta0
omega=omega0
tmax=5
angle=[theta0]
vitang=[omega0]
temps=[0]
while t<tmax:
    t = t + deltat
    theta=theta+omega*deltat
    omega=omega-3*g/2/a*sin(theta)*deltat
    temps.append(t)
    angle.append(theta)
    vitang.append(omega)
plot(temps,angle)
show()
   